<template>
    <div class="form_container">
        <div class="breadcrumbs">
            <router-link to="/main">{{$t('message.main')}}</router-link>
            <div class="circle"></div>
            <div>{{$t('message.profile')}}</div>
        </div>

        <form @submit.prevent="update_profile" class="form">
			<div class="block" style="padding-bottom: 0">
				<div class="block-title">{{$t('message.profile_update')}}</div>

                <div class="row">
                    <div class="input_component">
                        <input
                            type="text"
                            name="last_name"
                            v-bind:placeholder="$t('message.second_name')"
                            v-model='user.last_name'
                            @keypress='handleCyrilic'
                            :class="{active_focus: user.last_name}"
                        >
                        <div class="lbl">{{$t('message.second_name')}}</div>
                    </div>

                    <div class="input_component">
                        <input
                            type="text"
                            name="first_name"
                            v-model='user.first_name'
                            :placeholder="$t('message.first_name')"
                            @keypress='handleCyrilic'
                            :class="{active_focus: user.first_name}"
                        >
                        <div class="lbl">{{$t('message.first_name')}}</div>
                    </div>

                    <div class="input_component">
                        <input
                            type="text"
                            name="middle_name"
                            v-model='user.middle_name'
                            :placeholder="$t('message.last_name')"
                            @keypress='handleCyrilic'
                            :class="{active_focus: user.middle_name}"
                        >
                        <div class="lbl">{{$t('message.last_name')}}</div>
                    </div>
				</div>

				<div class="row">
                    <div class="input_component phone">
                        <the-mask
                            type="text"
                            name="phone"
                            :mask="['+38 (0##) ###-##-##']"
                            :value='phone'
                            :class="{'error':(!phone_is_valid || phone_is_exist ) && is_phone_changed, active_focus: !phone_err_msg}"
                        ></the-mask>
                        <div class="lbl">{{$t('message.phone')}}</div>
                    </div>

                    <div class="input_component">
                        <v-text-field
                            v-model='user.email'
                            :placeholder="$t('message.email')"
                            name='email'
                            :class="{error : (errors.email || !is_email_valid), parent_active_focus: user.email}"
                        >
                            <template slot="label">{{$t('message.email')}}</template>
                        </v-text-field>
                        <span v-if="email_error" class="label">{{this.email_error[0]}}</span>
                    </div>

                    <div class="input_component">
                        <datepicker
                            id='birthday'
                            v-model='user.birthday'
                            :placeholder="$t('message.birthday')"
                            name='birthday'
                            :monday-first=true
                            :language='uk'
                            format='dd.MM.yyyy'
                            :class="{error: errors.birthday, parent_active_focus: user.birthday}"
                            :disabled-dates="disabledDates"
                            :minimumView="'day'"
                            :maximumView="'year'"
                            :initialView="'year'"
                        >
                            <label slot="afterDateInput" class="v-label">{{$t('message.birthday')}}</label>
                        </datepicker>
                        <span v-if="email_error" class="label">{{this.email_error[0]}}</span>
                    </div>
				</div>

				<div class="row">
					<label class="checkbox_group" for="male" :class="user.gender == 1 ? 'active' : ''">
						<div class="radio"></div>
						<div class="text">{{$t('message.male')}}</div>
						<input
                            id="male"
                            type="radio"
                            name="gender"
                            value="1"
                            v-model="user.gender">
					</label>
					<label class="checkbox_group" for="female" :class="user.gender == 2 ? 'active' : ''">
                        <div class="radio"></div>
						<div class="text">{{$t('message.female')}}</div>
                        <input
                            id="female"
                            type="radio"
                            name="gender"
                            value="2"
                            v-model="user.gender">
					</label>
				</div>
			</div>

<!--			<div class="block color">-->
<!--                тут ничего не работет пока-->
<!--				<div class="block-title">{{$t('message.address')}}</div>-->
<!--				<div class="row">-->
<!--					<select-->
<!--						name="sity"-->
<!--						id=""-->
<!--						:value='custom_city ? custom_city : sity'-->
<!--					>-->
<!--						<option v-if="!sity" selected>Оберіть місто</option>-->
<!--						<option-->
<!--							v-for='city in cities'-->
<!--							:key='city.name_ua'-->
<!--							:selected='city.name_ua == sity'-->
<!--						>{{city.name_ua}}</option>-->
<!--					</select>-->
<!--					<div class="cities">-->
<!--						<div class="city" @click='custom_city="Київ"'>Київ</div>-->
<!--						<div class="city" @click='custom_city="Харків"'>Харків</div>-->
<!--					</div>-->
<!--				</div>-->

<!--				<div class="row last">-->
<!--					<input-->
<!--							type="text"-->
<!--							name="street"-->
<!--							:value='street'-->
<!--							:placeholder="$t('message.street')"-->

<!--					>-->
<!--					<input-->
<!--							type="text"-->
<!--							name="building"-->
<!--							:value='building'-->
<!--							:placeholder="$t('message.building')"-->

<!--					>-->
<!--					<input-->
<!--							type="text"-->
<!--							name="flat"-->
<!--							:value='flat'-->
<!--							:placeholder="$t('message.flat')"-->

<!--					>-->
<!--				</div>-->
<!--			</div>-->

			<div class="block buttons profile_update_buttons">
				<div class="row">
                    <button class="button" type="submit">{{$t('message.save')}}</button>
                    <router-link class="button fix-margin" to="/profile/update/password">{{$t('message.change_password')}}</router-link>

                    <label v-if='!accept' class="checkbox_group active">
						<div class="radio"></div>
						<div class="text">{{$t('message.agreement_message')}}<br/><a href="" target="_blank">{{$t('message.agreement_link_message')}}</a></div>
						<input type="checkbox" name="accept" v-model='accept'>
					</label>
				</div>
			</div>
        </form>
    </div>
</template>





<script>
    import Datepicker from 'vuejs-datepicker';
    import {uk} from 'vuejs-datepicker/dist/locale';

    export default {
        components: {
            Datepicker
        },
        beforeCreate() {

        },
        mounted() {
            this.$store.dispatch('set_profile');
            this.$store.dispatch('setCities');
        },
        data: () => {
            return {
                rules: {
                    required: value => !!value || 'Required.',
                    min: v => v.length >= 2 || 'Min 2 characters',
                    max: v => v.length <= 16 || 'Max 16 characters',
                    email: value => {
                        if(value.length){
                            const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+\.*)+([a-zA-Z]{2,})*))$/
                            return pattern.test(value) || 'Invalid e-mail.'
                        }
                    }
                },
                is_phone_changed: false,
                confirm_agreement: false,
                gender: '',
                custom_city: null,
                uk:uk,
                to_update: {},
            }
        },
        methods: {
            update_profile (e) {
                if(this.phone_is_exist){
                    this.$modal.show('error');
                    this.$store.dispatch('set_profile');
                    this.$store.state.user.phone = 0;
                    this.$store.state.phone_is_exist = false;
                    return;
                }
                let r = {};
                let a = ($(e.target).serializeArray());
                for(let v in a)
                {



                    //     // var from = a[v].value.split(".");
                    //     // console.log(a[v]);
                    //     // var f = new Date(from[2], from[1]-1, from[0], 0, ((new Date).getTimezoneOffset()*-1), 0 );
                    //     // f = '13.04.1992';
                    //
                    //     // console.log('new Date(from[2], from[1]-1, from[0], 0, ((new Date).getTimezoneOffset()*-1), 0 );',f)
                    //     // console.log('(new Date).getTimezoneOffset()',(new Date).getTimezoneOffset());
                    //
                    //     // r[a[v].name] = f;
                    //     r[a[v].name] = a[v].value;
                    if(a[v].name == 'phone'){
                        let o_phone = this.phone.replace(new RegExp(/(\-|\(|\)|\s)/, 'g'),'');
                        let n_phone = a[v].value.replace(new RegExp(/(\-|\(|\)|\s)/, 'g'),'');
                        this.is_phone_changed = (o_phone !== n_phone);
                        if(this.is_phone_changed){
                            this.$store.dispatch('validate_phone', n_phone);
                        }
                        // if(is_phone_changed) {
                        //     let is_phone_valid =
                        // }
                        // axios
                        //     .post('/profile/changeOldPhone', {old_phone: o_phone, new_phone: n_phone})
                        //     .then(response => {
                        //
                        //         if(!response.data.is_valid)
                        //         {
                        //             state.commit('set_phone_err_msg', response.data[0].phone[0]);
                        //             if(response.data.is_exist)
                        //             {
                        //                 state.commit('set_phone_is_exist', response.data.is_exist);
                        //             }
                        //         }
                        //         state.commit('set_phone_status', response.data.is_valid);
                        //
                        //     })

                    }

                    if(a[v].name == 'birthday'){
                        let from = a[v].value.split(".");
                        var f = new Date(from[2], from[1]-1, from[0], 6, 0, 0 );
                        r[a[v].name] = f;
                    } else {
                        r[a[v].name] = a[v].value
                    }
                }

                // TODE for debug
                // r.phone = '+380999999992';
                // if phone doesn`t changed
                if (this.is_phone_changed)
                {this.$store.state.to_update = r;}
                else {this.$store.dispatch('update_profile', r);}
            },
            handleCyrilic (e) {
                if(!(/[абвгґдеєжзиіїйклмнопрстуфхцчшщьюяАБВГҐДЕЄЖЗИІЇЙКЛМНОПРСТУФХЦЧШЩЬЮЯ\-\'\s]/.test(e.key)) && e.key)
                {
                    e.preventDefault();
                    return false;
                }

                // e.target.value = e.target.value.substring(0, e.target.value.length - 1);
            },
            onSuccessOpened () {
                setTimeout(() => {this.$modal.hide('success')}, 1000);
            },
            log(e){alert(e)},

        },
        // TODO use getterMap or someMap
        computed: {
            user () {
                return this.$store.getters.user;
            },
            // first_name() {return this.user.first_name + 112},
            // middle_name() {return  this.$store.state.user.middle_name},
            // last_name() {return  this.$store.getters.user.last_name},
            // email() {return  this.$store.state.user.email},
            // birthday() {return  this.$store.state.user.birthday},
            sity() {return  'some'},
            street() {return  'some'},
            building() {return  'some'},
            flat() {return  'some'},
            phone() {return this.$store.state.user.phone},
            cities() {return this.$store.getters.cities},
            accept: {
                get() {
                    return true;
                    return this.$store.state.user.profile.accept;
                },
                set(n) {
                    this.confirm_agreement = n;
                }
            },
            // p_gender() {
            // return this.gender;
            // this.gender = this.$store.state.user.gender;
            // },
            errors() {
                return this.$store.getters.errors;
            },
            is_success() {
                return this.$store.getters.is_success;
            },
            disabledDates() {
                let date = new Date;
                date.setFullYear(date.getFullYear() - 16);
                return {from: date};
            },
            is_email_valid: function () {
                if(!this.user.email) return true;
                const pattern = /^(([^<>()[\]\\.,;:\s@"]+(\.[^<>()[\]\\.,;:\s@"]+)*)|(".+"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}])|(([a-zA-Z\-0-9]+)+(\.*[a-zA-Z]{2,})*))$/
                return pattern.test(this.user.email)
            },
            email_error: function () {
                return this.$store.getters.errors.email;
            },
            phone_is_valid: function () {
                return this.$store.getters.phone_is_valid;
            },
            phone_is_exist: function () {
                return this.$store.getters.phone_is_exist;
            },
            phone_err_msg: function () {
                return this.$store.getters.phone_err_msg;
            },
            show_send_code: function () {
                return (this.phone_is_valid && this.is_phone_changed);
            }
        },
        watch: {
            errors: function () {
                // if(Object.keys(this.$store.getters.errors).length)
                // {
                //
                // }
                // this.$modal.show('error');

                return this.$store.getters.errors;
            },
            is_success: function () {
                if(this.$store.getters.is_success)
                {
                    this.$modal.show('success');
                    if(this.is_phone_changed) {
                        window.location = '/logout';
                    }
                }

                this.$store.dispatch('refresh_is_success')
            },
            show_send_code: function (n) {
                if(n) this.$modal.show('send_code');
                if(!n) {this.$modal.hide("send_code");this.$store.state.user.phone = 0};
            },
            phone_is_exist: function (n) {
                this.$modal.show('error');
                this.$store.state.user.phone = '';
                this.$store.dispatch('set_profile');
                this.$store.state.phone_is_exist = false;
                // return
            },
            phone_err_msg: function (n) {
                if(n) this.$modal.show('error');
            }
            // phone_is_valid: function (n) {
            //     console.log(n)
            //     this.$modal.show('error');
            //     this.$store.dispatch('set_profile');
            //     this.$store.state.user.phone = 0;
            //     return this.$store.state.phone_is_valid = true;
            // }

        },
    }
</script>
